library mFUNC;
uses
Windows,
messages,
kol; { http://xcl.cjb.net }

var
SmoothFonts:Boolean;

function _Strtoint (s:string) : integer;
var i,error_code:integer;
begin
val (s,i,error_code);
_strtoint:=i;
end;

function _inttostr(i:integer) : string;
var s:string;
begin
str(i,s);
_inttostr:=s;
end;

function NumTok(aString, SepChar: String):Byte;
var
R: Char;
StrLen,TNum,TEnd: Byte;
begin
if SepChar = '#' then
begin
R := '*'
end
else
begin
R := '#'
end;
StrLen := Length(aString);
TNum   := 0;
TEnd   := StrLen;
while TEnd <> 0 do
begin
Inc(TNum);
TEnd := Pos(SepChar,aString);
if TEnd <> 0 then
begin
aString[TEnd] := R;
end;
end;
Result := TNum;
end;

function GetTok(aString, SepChar: String; TokenNum: Byte):String;
var
Token : String;
StrLen: Byte;
TNum:Byte;
TEnd:Byte;
begin
StrLen := Length(aString);
TNum   := 1;
TEnd   := StrLen;
while ((TNum <= TokenNum) and (TEnd <> 0)) do
begin
TEnd := Pos(SepChar,aString);
if TEnd <> 0 then
begin
Token := Copy(aString,1,TEnd-1);
Delete(aString,1,TEnd);
Inc(TNum);
end
else
begin
Token := aString;
end;
end;
if TNum >= TokenNum then
begin
GetTok := Token;
end
else
begin
GetTok := '';
end;
end;

Function StrToColorType(A: String): Integer;
var N:integer;
Begin
N:=1000;
if A = '3DDKSHADOW' then N := COLOR_3DDKSHADOW;
if A = '3DFACE' then N := COLOR_3DFACE;
if A = 'BTNFACE' then N := COLOR_BTNFACE;
if ((A = '3DHILIGHT') or (a = '3DHIGHLIGHT') or (a = 'BTNHILIGHT') or (a = 'BTNHIGHLIGHT')) then N := COLOR_3DHIGHLIGHT;
if A = '3DLIGHT' then N :=COLOR_3DLIGHT;
if ((A = '3DSHADOW') or (A = 'BTNSHADOW')) then N :=COLOR_3DSHADOW;
if A = 'ACTIVEBORDER' then N :=COLOR_ACTIVEBORDER;
if A = 'ACTIVECAPTION' then N :=COLOR_ACTIVECAPTION;
if A = 'APPWORKSPACE' then N :=COLOR_APPWORKSPACE;
if (A = 'BACKGROUND') or (A = 'DESKTOP') then N :=COLOR_BACKGROUND;
if A = 'BTNTEXT' then N :=COLOR_BTNTEXT;
if A = 'CAPTIONTEXT' then N :=COLOR_CAPTIONTEXT;
if A = 'GRAYTEXT' then N :=COLOR_GRAYTEXT;
if A = 'HIGHLIGHT' then N :=COLOR_HIGHLIGHT;
if A = 'HIGHLIGHTTEXT' then N :=COLOR_HIGHLIGHTTEXT;
if A = 'INACTIVEBORDER' then N :=COLOR_INACTIVEBORDER;
if A = 'INACTIVECAPTION' then N :=COLOR_INACTIVECAPTION;
if A = 'INACTIVECAPTIONTEXT' then N :=COLOR_INACTIVECAPTIONTEXT;
if A = 'INFOBK' then N :=COLOR_INFOBK;
if A = 'INFOTEXT' then N :=COLOR_INFOTEXT;
if A = 'MENU' then N :=COLOR_MENU;
if A = 'MENUTEXT' then N :=COLOR_MENUTEXT;
if A = 'SCROLLBAR' then N :=COLOR_SCROLLBAR;
if A = 'WINDOW' then N :=COLOR_WINDOW;
if A = 'WINDOWFRAME' then N :=COLOR_WINDOWFRAME;
if A = 'WINDOWTEXT' then N :=COLOR_WINDOWTEXT;
Result:=N;
end;

Function isokfile(f:string):integer;
var I:integer;
begin
i:=length(f)-3;
if (copy(f,i,4) = '.bmp') then result:= 1
else result:=0;
end;

Function DirExists(s:string):integer;
Begin
{$I-}
ChDir(s);
result:=ioresult;
{$I+}
end;

procedure GETSCREEN(N:integer;F:String);
var
w,h:integer;
DC,DCWind: HWND;
Bmp:PBitmap;
rect:TRect;
begin

if (N = 1) then begin
DCWind := GetForeGroundWindow;
GetWindowRect(DCWind, rect);
end
else begin
DCWind := GetDesktopWindow;
GetWindowRect(DCWind, rect);
end;
try
if (N = 2) then begin
w:=GetSystemMetrics(SM_CXSCREEN);
H:= GetSystemMetrics(SM_CYSCREEN);
DC:=GetDC(0);
end
else begin
w:=rect.right-rect.left;
H:=rect.Bottom-rect.Top;
DC:=GetDC(GetDesktopWindow);
end;
bmp:=NewDIBBitmap(w,h,pf32bit);
try
BitBlt(bmp.Canvas.handle, 0, 0,W,H,DC,rect.left,rect.Top,SRCCOPY);
bmp.SaveToFile(f);
finally
ReleaseDC(GetDesktopWindow, DC);
ReleaseDC(0, DC);
end;
finally
ReleaseDC(GetForeGroundWindow, DCWind);
ReleaseDC(0, DCWind);
end;
bmp.Free;
end;


FUNCTION INFO( mWnd: hWnd; aWnd: hWnd; Data: pchar; Parms: PChar;
Show: Boolean; NoPause: Boolean ): Integer; export; stdcall;
begin
lstrCpy(data, 'mFUNC.dll 1.0');
result :=3;
end;

FUNCTION GETCOLOR( mWnd: hWnd; aWnd: hWnd; Data: pchar; Parms: PChar;
Show: Boolean; NoPause: Boolean ): Integer; export; stdcall;
var
c,t:integer;
begin
c:=StrToColorType(data);
t:=GetSysColor(c);
if (c = 1000) then begin
lStrCpy(data, 'ERR');
result:=3
end
else begin
lStrCpy(data, PChar(_inttostr(t)));
result:=3
end;
end;

FUNCTION SETLAYER(mWnd: hWnd; aWnd: hWnd; Data: pchar; Parms: PChar;
Show: Boolean; NoPause: Boolean ): Integer; export; stdcall;
var
 exStyle : LongInt;
 h,n,c:integer;
begin
h:=_strtoint(Gettok(data,' ',1));
n:=_strtoint(Gettok(data,' ',2));
c:=_strtoint(Gettok(data,' ',3));
exStyle:=GetWindowLong(h, GWL_EXSTYLE);
if (Gettok(data,' ',2) = 'off') then begin
SetWindowLong(h,GWL_EXSTYLE, exstyle and not WS_EX_LAYERED);
end
else begin
SetWindowLong(h, GWL_EXSTYLE, exStyle or WS_EX_LAYERED);
if (Numtok(data,' ') = 3) then SetLayeredWindowAttributes(h, c, n, LWA_COLORKEY)
else SetLayeredWindowAttributes(h, 0, n, LWA_ALPHA);
end;
lstrCpy(data, 'OK');
result := 3;
end;


FUNCTION ISFONTSMOOTH(mWnd: hWnd; aWnd: hWnd; Data: pchar; Parms: PChar;
Show: Boolean; NoPause: Boolean ): Integer; export; stdcall;
var
t:string;
begin
t:='$false';
SystemParametersInfo(SPI_GETFONTSMOOTHING, 1, @SmoothFonts, 0);
if SmoothFonts then t:='$true';
lstrcpy(data, pchar(t));
result := 3;
end;

FUNCTION SCREENSHOT(mWnd: hWnd; aWnd: hWnd; Data: pchar; Parms: PChar;
Show: Boolean; NoPause: Boolean ): Integer; export; stdcall;
var
S,F,T,M:string;
n:integer;
begin
S:=Gettok(data,' ',1);
for N:=2 to numtok(data,' ') do begin
f:=F+Gettok(data,' ',N);
end;
for N:=1 to numtok(f,'\')-1 do begin
t:=t+Gettok(f,'\',N)+'\';
end;
f:=Gettok(f,'\',numtok(f,'\'));
m:='ERR';
if (isokfile(f) = 1) and (DirExists(t) = 0) then begin
m:='OK';
if (s = 'ACTIVE') then GETSCREEN(1,f)
else GETSCREEN(2,f);
end;
lstrcpy(data, pchar(m));
result := 3;
end;

exports
SCREENSHOT,
ISFONTSMOOTH,
SETLAYER,
GETCOLOR,
INFO;

end.
